function removeHotupdaeAssets(){
    if (window.jsb) {
        var storagePath = jsb.fileUtils.getWritablePath();
        var hotpath = storagePath + "hotupdate";
        // remove一个不存在的目录，也是会返回true
        if(jsb.fileUtils.removeDirectory(hotpath+"/")){
            console.log("=========removeHotupdaeAssets success:"+hotpath+"/");
            if(jsb.fileUtils.removeDirectory(hotpath+"_temp/")){
                console.log("=========removeHotupdaeAssets temp success:"+hotpath+"_temp/");
            }
            return true;
        }
    }

    return false;
};

// 设置热更新搜索目录
function setHotupdateSearchDir(){
    if (window.jsb) {

        var storagePath = jsb.fileUtils.getWritablePath();
        var hotpath = storagePath + "hotupdate";

        // 如果当前svnVersion比本地保存的大，直接删除热更新目录
        var saveVersion = localStorage.getItem("svnVersion");
        if(!saveVersion){
            saveVersion = 0;
        }
        saveVersion = parseInt(saveVersion);
        var localSvnVersion = xkmaojsb.getBuildSvnVersion();
        if(!localSvnVersion){
            localSvnVersion = 0;
        }
        localSvnVersion = parseInt(localSvnVersion);
        if(localSvnVersion == 7465){
            // 清除旧的测试版本账号信息，因为数据库已经重置了
            localStorage.setItem("visit_aid", "0");
            localStorage.setItem("default_aid", "0");
            localStorage.setItem("sdkBid","");
        }
        console.log("=======localSvnVersion:"+localSvnVersion+"  saveVersion:"+saveVersion);
        if(localSvnVersion > saveVersion){
            if(removeHotupdaeAssets()){
                console.log("========removeDirectory because localSvnVersion>saveVersion success");
                // 是新版本客户端，要删除以前的热更新成功后，才会设置新的客户端版本号
                localStorage.setItem("svnVersion",localSvnVersion+"");
            }
        }else{
            localStorage.setItem("svnVersion",localSvnVersion+"");
        }
        // 保证热更新目录存在
        if (!jsb.fileUtils.isDirectoryExist(hotpath)) {
            jsb.fileUtils.createDirectory(hotpath);
        }

        var HotUpdateSearchPaths = localStorage.getItem('HotUpdateSearchPaths');
        if (HotUpdateSearchPaths) {
            jsb.fileUtils.setSearchPaths(JSON.parse(HotUpdateSearchPaths));
        }
        console.log("=========HotUpdateSearchPaths:"+HotUpdateSearchPaths);

        // var hotUpdateSearchPaths = jsb.fileUtils.getSearchPaths(); 
        // hotUpdateSearchPaths.unshift(hotpath);
        // jsb.fileUtils.setSearchPaths(hotUpdateSearchPaths);
        // console.log("hotUpdateSearchPaths:"+JSON.stringify(hotUpdateSearchPaths));
    }
};

window.boot = function () {
    var settings = window._CCSettings;
    window._CCSettings = undefined;
    var onProgress = null;
    
    var RESOURCES = cc.AssetManager.BuiltinBundleName.RESOURCES;
    var INTERNAL = cc.AssetManager.BuiltinBundleName.INTERNAL;
    var MAIN = cc.AssetManager.BuiltinBundleName.MAIN;
    function setLoadingDisplay () {
        // Loading splash scene
        var splash = document.getElementById('splash');
        var progressBar = splash.querySelector('.progress-bar span');
        onProgress = function (finish, total) {
            var percent = 100 * finish / total;
            if (progressBar) {
                progressBar.style.width = percent.toFixed(2) + '%';
            }
        };
        splash.style.display = 'block';
        progressBar.style.width = '0%';

        cc.director.once(cc.Director.EVENT_AFTER_SCENE_LAUNCH, function () {
            splash.style.display = 'none';
        });
    }

    var onStart = function () {

        cc.view.enableRetina(true);
        cc.view.resizeWithBrowserSize(true);

        if (cc.sys.isBrowser) {
            setLoadingDisplay();
        }

        if (cc.sys.isMobile) {
            if (settings.orientation === 'landscape') {
                cc.view.setOrientation(cc.macro.ORIENTATION_LANDSCAPE);
            }
            else if (settings.orientation === 'portrait') {
                cc.view.setOrientation(cc.macro.ORIENTATION_PORTRAIT);
            }
            cc.view.enableAutoFullScreen([
                cc.sys.BROWSER_TYPE_BAIDU,
                cc.sys.BROWSER_TYPE_BAIDU_APP,
                cc.sys.BROWSER_TYPE_WECHAT,
                cc.sys.BROWSER_TYPE_MOBILE_QQ,
                cc.sys.BROWSER_TYPE_MIUI,
                cc.sys.BROWSER_TYPE_HUAWEI,
                cc.sys.BROWSER_TYPE_UC,
            ].indexOf(cc.sys.browserType) < 0);
        }

        // Limit downloading max concurrent task to 2,
        // more tasks simultaneously may cause performance draw back on some android system / browsers.
        // You can adjust the number based on your own test result, you have to set it before any loading process to take effect.
        if (cc.sys.isBrowser && cc.sys.os === cc.sys.OS_ANDROID) {
            cc.assetManager.downloader.maxConcurrency = 2;
            cc.assetManager.downloader.maxRequestsPerFrame = 2;
        }

        var launchScene = settings.launchScene;
        var bundle = cc.assetManager.bundles.find(function (b) {
            return b.getSceneInfo(launchScene);
        });
        
        bundle.loadScene(launchScene, null, onProgress,
            function (err, scene) {
                if(err){
                    console.log("main===========loadScene:"+err.message,err);
                    removeHotupdaeAssets();
                }
                if (!err) {
                    cc.director.runSceneImmediate(scene);
                    if (cc.sys.isBrowser) {
                        // show canvas
                        var canvas = document.getElementById('GameCanvas');
                        canvas.style.visibility = '';
                        var div = document.getElementById('GameDiv');
                        if (div) {
                            div.style.backgroundImage = '';
                        }
                        console.log('Success to load scene: ' + launchScene);
                    }
                }
            }
        );

    };

    var option = {
        id: 'GameCanvas',
        debugMode: settings.debug ? cc.debug.DebugMode.INFO : cc.debug.DebugMode.ERROR,
        showFPS: settings.debug,
        frameRate: 60,
        groupList: settings.groupList,
        collisionMatrix: settings.collisionMatrix,
    };

    cc.assetManager.init({ 
        bundleVers: settings.bundleVers,
        remoteBundles: settings.remoteBundles,
        server: settings.server
    });
    
    var bundleRoot = [INTERNAL];
    settings.hasResourcesBundle && bundleRoot.push(RESOURCES);

    var count = 0;
    function cb (err) {
        if (err) return console.error(err.message, err.stack);
        count++;
        if (count === bundleRoot.length + 1) {
            cc.assetManager.loadBundle(MAIN, function (err) {
                if (!err) cc.game.run(option, onStart);
            });
        }
    }

    cc.assetManager.loadScript(settings.jsList.map(function (x) { return 'src/' + x;}), cb);

    for (var i = 0; i < bundleRoot.length; i++) {
        cc.assetManager.loadBundle(bundleRoot[i], cb);
    }
};

if (window.jsb) {
    try{
        // 设置热更新搜索目录，一定要在require('src/settings.js')之前，否则热更新的图片会不生效
        setHotupdateSearchDir();

        var isRuntime = (typeof loadRuntime === 'function');
        if (isRuntime) {
            require('src/settings.js');
            require('src/cocos2d-runtime.js');
            if (CC_PHYSICS_BUILTIN || CC_PHYSICS_CANNON) {
                require('src/physics.js');
            }
            require('jsb-adapter/engine/index.js');
        }
        else {
            require('src/settings.js');
            require('src/cocos2d-jsb.js');
            if (CC_PHYSICS_BUILTIN || CC_PHYSICS_CANNON) {
                require('src/physics.js');
            }
            require('jsb-adapter/jsb-engine.js');
        }

        cc.macro.CLEANUP_IMAGE_CACHE = true;
        window.boot();
    }catch(e){
        console.log("main===========jsb:"+e.message,e);
        removeHotupdaeAssets();
    }
}